<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="18">
        <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="0" @submit.native.prevent>
          <el-form-item label="" prop="tplName" style="margin-right:10px">
            <el-input
                v-model="queryParams.tplName"
                placeholder="请输入模板名称"
                clearable
                @keyup.enter="handleQuery"
            />
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
      </el-col>
      <el-col :span="6" style="text-align: right">
        <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-if="!selectTpl"
            v-hasPermi="['metrics:tpl:add']"
        >新增
        </el-button>
      </el-col>
    </el-row>
    <el-table v-loading="loading" :data="tplList" border  @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" v-if="selectTpl"/>
      <el-table-column label="模板ID" align="center" prop="tplId" width="80"/>
      <el-table-column label="模板名称" align="left" prop="tplName"/>
      <el-table-column label="指标数量" align="left" prop="num" width="150"/>
      <el-table-column label="创建时间" align="center" prop="createTime" width="200" v-if="!selectTpl">
        <template #default="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d} {h}:{mi}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="left" class-name="small-padding fixed-width" :width="selectTpl?200:280">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['metrics:tpl:edit']" v-if="!selectTpl">
            修改
          </el-button>
          <el-button link type="primary" icon="Position" v-hasPermi="['metrics:detail:list']" @click="handleDetail(scope.row)">指标管理</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['metrics:tpl:remove']">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
    />

    <!-- 添加或修改指标模板对话框 -->
    <el-dialog :title="title" v-model="open" :width="dialogType === 'add' ? 500 : 1200" append-to-body>
      <el-form ref="tplRef" :model="form" :rules="rules" label-width="80px" v-if="dialogType === 'add'">
        <el-form-item label="模板名称" prop="tplName">
          <el-input v-model="form.tplName" placeholder="请输入模板名称"/>
        </el-form-item>
        <el-form-item label="备注">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" :autosize="{maxRows:6,minRows:3}" maxlength="300" show-word-limit/>
        </el-form-item>
      </el-form>
      <indicator-manger v-else ref="uRef" @updateList="getList"/>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm" v-if="dialogType === 'add'">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Tpl">
import {addTpl, delTpl, getTpl, listTpl, updateTpl} from "@/api/metrics/tpl";
import indicatorManger from "./component/indicatorManger.vue"

const props = defineProps({
  selectTpl: {
    type: Boolean,
    default: false
  }
})

const {proxy} = getCurrentInstance();

const uRef = ref(null)
const tplList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const daterangeCreateTime = ref([]);
const daterangeUpdateTime = ref([]);

const dialogType = ref("add")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    tplName: null,
    remark: null
  },
  rules: {
    tplName: [
      {required: true, message: "模板名称不能为空", trigger: "blur"}
    ],
  }
});

const {queryParams, form, rules} = toRefs(data);

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.tplId);
}

function emitIds(){
  let arr=[]
  tplList.value.forEach(p=>{
    if(ids.value.indexOf(p.tplId)!==-1){
      arr.push({...p})
    }
  })
  return arr;
}

defineExpose({emitIds})

/** 查询指标模板列表 */
function getList() {
  loading.value = true;
  queryParams.value.params = {};
  if (null != daterangeCreateTime && '' != daterangeCreateTime) {
    queryParams.value.params["beginCreateTime"] = daterangeCreateTime.value[0];
    queryParams.value.params["endCreateTime"] = daterangeCreateTime.value[1];
  }
  if (null != daterangeUpdateTime && '' != daterangeUpdateTime) {
    queryParams.value.params["beginUpdateTime"] = daterangeUpdateTime.value[0];
    queryParams.value.params["endUpdateTime"] = daterangeUpdateTime.value[1];
  }
  listTpl(queryParams.value).then(response => {
    tplList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    tplId: null,
    tplName: null,
    tplCode: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("tplRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  daterangeCreateTime.value = [];
  daterangeUpdateTime.value = [];
  proxy.resetForm("queryRef");
  handleQuery();
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加指标模板";
  dialogType.value = "add"
}

function handleDetail(row){
  open.value = true;
  title.value = "指标管理";
  dialogType.value = "details"
  nextTick(()=>{
    uRef.value.getSelectDetails(row.tplId)
  })
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _tplId = row.tplId || ids.value
  getTpl(_tplId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改指标模板";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["tplRef"].validate(valid => {
    if (valid) {
      if (form.value.tplId != null) {
        updateTpl(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addTpl(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _tplIds = row.tplId || ids.value;
  proxy.$modal.confirm('是否确认删除指标模板编号为"' + _tplIds + '"的数据项？').then(function () {
    return delTpl(_tplIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {
  });
}

getList();
</script>
